﻿namespace AsyncAwait
{
    internal class Program
    {
        static async void Main2()
        {
            Func<object, long> akcja =
                (object argument) =>
                {
                    Console.WriteLine($"Początek działania akcji - {argument}, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId().ToString()}");
                    Thread.Sleep(500);
                    Console.WriteLine($"Koniec działania akcji, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId().ToString()}");
                    return DateTime.Now.Ticks;
                };

            //async/await
            Task<long> zadanie2 = new Task<long>(akcja, "zadanie");
            zadanie2.Start();
            Console.WriteLine($"Przed uruchomiem zadania, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId().ToString()}");
            long wynik = await zadanie2; //synchronizacja?
            Console.WriteLine($"Po uruchomiu zadania, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId().ToString()}");
            Console.WriteLine("Zadanie: " + wynik.ToString());
        }

        static void Main(string[] args)
        {
            Func<object, long> akcja =
                (object argument) =>
                {
                    Console.WriteLine($"Początek działania akcji - {argument}, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId().ToString()}");
                    Thread.Sleep(500);
                    Console.WriteLine($"Koniec działania akcji, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId().ToString()}");
                    return DateTime.Now.Ticks;
                };

            //sekwencyjnie
            Console.WriteLine($"Przed uruchomiem akcji, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId}");
            long wynik = akcja("synchronicznie");
            Console.WriteLine($"Po uruchomiu akcji, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId}");
            Console.WriteLine("Synchronicznie: " + wynik.ToString() + "\n\n");

            //w osobnym zadaniu
            Task<long> zadanie = new Task<long>(akcja, "zadanie");                        
            Console.WriteLine($"Przed uruchomiem zadania, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId}");
            zadanie.Start();
            Console.WriteLine($"Po uruchomiu zadania, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId}");
            //synchronizacja            
            wynik = zadanie.Result; //czekanie, aż zadanie się skończy
            Console.WriteLine("Zadanie: " + wynik.ToString() + "\n\n");

            Main2();
            Console.WriteLine($"Naciśnij Enter, {Thread.CurrentThread.ManagedThreadId}, {Thread.GetCurrentProcessorId}");
            Console.ReadLine();
        }
    }
}