﻿class Program
{
    static private double obliczenia(double argument)
    {        
        for(int i = 0; i < 1000; ++i)
        {
            argument = Math.Asin(Math.Sin(argument));
        }
        return argument;
    }

    static private void Main()
    {
        //przygotowania
        int rozmiar = 10000;
        Random r = new Random();
        double[] tablica = new double[rozmiar];
        for (int i = 0; i < tablica.Length; i++) tablica[i] = r.NextDouble();

        /*
        //obliczenia sekwencyjne
        int liczbaPowtórzeń = 100;
        double[] wyniki = new double[tablica.Length];
        int start = Environment.TickCount;
        for (int powtórzenia = 0; powtórzenia < liczbaPowtórzeń; ++powtórzenia)
        {
            for (int i = 0; i < tablica.Length; ++i)
                wyniki[i] = obliczenia(tablica[i]);            
        }
        int stop = Environment.TickCount;
        int ts = stop - start;
        Console.WriteLine("Obliczenia sekwencyjne trwały " + ts.ToString() + " ms.");

        //obliczenia równoległe                
        start = Environment.TickCount;
        for (int powtórzenia = 0; powtórzenia < liczbaPowtórzeń; ++powtórzenia)
        {
            Parallel.For(0, tablica.Length, (int i) => wyniki[i] = obliczenia(tablica[i]));
        }
        stop = Environment.TickCount;
        int tr = stop - start;
        Console.WriteLine("Obliczenia sekwencyjne trwały " + tr.ToString() + " ms.");
        Console.WriteLine("Przyspieszenie: " + (1.0 * ts / tr).ToString());
        */

        //przerywanie pętli równoległej
        Parallel.For(
            0,
            1000,
            (int i, ParallelLoopState stanPętli) =>
            {
                string s = "";
                int liczba = r.Next(7);                
                if (liczba == 0)
                {
                    s = "Stop:";
                    stanPętli.Stop();
                }
                if (stanPętli.IsStopped)
                {
                    Console.Write(s);
                    return;
                }
                if (liczba % 2 == 0)
                {
                    s = "Parzysta";
                }
                else
                {
                    s = "Nieparzysta";
                }
                Console.Write(s);
            });

        Console.WriteLine("Koniec");
    }
}